//
// Copyright (c) 2022 Arm Limited
// SPDX-License-Identifier: MIT

#ifndef ELROND_HELPERS_H
#define ELROND_HELPERS_H

// generated by cmake
#include <elrond_helpers/gen_config.h>

#include <sel4/sel4.h>


// limits of seL4 badges
#define ELROND_NTFN_MASK        0x8000000000000000UL
#define ELROND_CALL_MAX         0x7fffffffffffffffUL
#define ELROND_NTFN_MAX         63UL
#define ELROND_CALL_BADGE(x)    ((x) + 1)
#define ELROND_NTFN_BADGE(x)    (ELROND_NTFN_MASK | (((seL4_Word)1) << (x)))
#define ELROND_WAKEUP_BADGE     0x8000000000000000UL
#define ELROND_NULL_BADGE       0x0000000000000000UL

// predefined capability slots
enum elrond_slots {
    ELROND_CAP_NULL             = 0,
    ELROND_CAP_MAIN_TCB         = 1,
    ELROND_CAP_ASID_POOL        = 2,
    ELROND_CAP_CSPACE_ROOT      = 3,
    ELROND_CAP_VSPACE_ROOT      = 4,
    ELROND_CAP_FAULT_EP         = 5,
    ELROND_CAP_MAIN_CALL_EP     = 6,
    ELROND_CAP_MAIN_NTFN_EP     = 7,
    ELROND_RESERVED_CAP_COUNT   = 8,
};


// attribute for types that are filled in during elf loading
#define ELROND_INFO__(_name, _pointer, _counter) \
    __attribute__((used, section(".note.elrond.info." _name ",\"\",@note//"))) \
    static const void *__elrond_info_##_counter = _pointer;
#define ELROND_INFO_(_name, _var, _counter) \
    ELROND_INFO__(_name, _var, _counter)
#define ELROND_INFO(_name, _var) \
    ELROND_INFO_(_name, _var, __COUNTER__)

// attribute for callbacks that are handled by elrond_poll/elrond_spin
typedef struct elrond_cb {
    seL4_Word badge;
    union {
        void (*call_cb)(seL4_MessageInfo_t msg);
        void (*ntfn_cb)(void);
    } cb;
} elrond_cb_t;

#define ELROND_CALL_CB__(_name, _cb, _counter) \
    __attribute__((section("__elrond_call_cbs"))) \
    static const elrond_cb_t __elrond_call_cb_##_counter = { \
        .badge = 0, \
        .cb.call_cb = _cb, \
    }; \
    __attribute__((section(".note.elrond.info." _name "_badge,\"\",@note//"))) \
    static const void *__elrond_info_##_counter \
            = &__elrond_call_cb_##_counter.badge;
#define ELROND_CALL_CB_(_name, _cb, _counter) \
    ELROND_CALL_CB__(_name, _cb, _counter)
#define ELROND_CALL_CB(_name, _cb) \
    ELROND_CALL_CB_(_name, _cb, __COUNTER__)

#define ELROND_NTFN_CB__(_name, _cb, _counter) \
    __attribute__((section("__elrond_ntfn_cbs"))) \
    static const elrond_cb_t __elrond_ntfn_cb_##_counter = { \
        .badge = 0, \
        .cb.ntfn_cb = _cb, \
    }; \
    __attribute__((section(".note.elrond.info." _name "_badge,\"\",@note//"))) \
    static const void *__elrond_info_##_counter \
            = &__elrond_ntfn_cb_##_counter.badge;
#define ELROND_NTFN_CB_(_name, _cb, _counter) \
    ELROND_NTFN_CB__(_name, _cb, _counter)
#define ELROND_NTFN_CB(_name, _cb) \
    ELROND_NTFN_CB_(_name, _cb, __COUNTER__)


// poll for any outstanding calls/notifications
void elrond_poll(void);

// give other threads a chance to run, and also poll calls/notifications
void elrond_yield(void);

// wait until new calls/notifications
void elrond_wait(void);

// spin waiting for new calls/notifications
__attribute__((noreturn))
void elrond_spin(void);

// abort our process
__attribute__((noreturn))
void elrond_abort(void);


#endif
